-----------------GENERAL PURPOSES TABLES------------------------------------------------

DROP TABLE IF EXISTS adresse;
CREATE TABLE IF NOT EXISTS adresse (
	aid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	boite_postal 				varchar(128) NULL,
	rue 						varchar(128) NOT NULL,
	ville 						varchar(128) NOT NULL,
	pays 						varchar(128) NOT NULL,
	telephone 					varchar(128) NULL,
	email 						varchar(128) NULL,
	web 						varchar(128) NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(125) NULL,
	
	CONSTRAINT primary_key_adress PRIMARY KEY (telephone)
);


-----------------REFERENCE TABLES------------------------------------------------

CREATE TABLE IF NOT EXISTS ref_assureur (
	aid int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assureur varchar(128) NOT NULL,
	nom varchar(128),
	CONSTRAINT pk_ref_ass PRIMARY KEY (code_assureur)
);
CREATE INDEX idx_assureur ON ref_assureur(code_assureur);


CREATE TABLE IF NOT EXISTS ref_intermediaire (
	riid int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	identifiant_dna varchar(128) NOT NULL,
	nom varchar(128),
	statut varchar(64),
	CONSTRAINT pk_ref_intermediaire PRIMARY KEY (identifiant_dna)
);
CREATE INDEX idx_ref_intermediaire ON ref_intermediaire(identifiant_dna);


CREATE TABLE IF NOT EXISTS ref_type_assureur (
	rtaid int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	nom varchar(128),
	code 	NUMERIC NOT NULL
);


CREATE TABLE IF NOT EXISTS ref_categorie_vehicule (
	rcvid 	int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code 	varchar(8) NOT NULL,
	CONSTRAINT pk_categorie_vehicule PRIMARY KEY (code)
);


CREATE TABLE IF NOT EXISTS ref_couleur_attestation (
	rcaid 	int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	nom 	varchar(128),
	code 	NUMERIC NOT NULL,
	CONSTRAINT pk_couleur_attestation PRIMARY KEY (code)
);


CREATE TABLE IF NOT EXISTS ref_status_attestation (
	rsaid 	int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	nom 	varchar(128),
	code 	NUMERIC NOT NULL,
	CONSTRAINT pk_code_attestation PRIMARY KEY (code)
);


-----------------BUSINES ENTITIES TABLES------------------------------------------------

CREATE TABLE IF NOT EXISTS assure (
	aid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 				varchar(128) NOT NULL,
	code_assureur 				varchar(128) NOT NULL,
	qualite 					varchar(128) NOT NULL,
	nom 						varchar(128) NOT NULL,
	prenom 						varchar(128) NULL,
	profession 					varchar(128) NOT NULL,
	date_naissance 				date NULL,
	num_contribuable 			varchar(128) NOT NULL,
	ville 						varchar(128) NULL,
	rue 						varchar(128) NULL,
	boite_postale 				varchar(128) NULL,
	telephone 					varchar(128) NULL,
	email 						varchar(128) NULL,
	numero_permis 				varchar(128) NULL,
	categorie_permis 			varchar(128) NULL,
	date_delivrance 			date NULL,
	permis_delivre_par 			varchar(128) NULL,
	nom_prenom_conducteur 		varchar(128) NULL,
	date_naissance_conducteur 	date NULL,
	c_status					numeric NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(254) NULL,
	
	CONSTRAINT pk_assure PRIMARY KEY (code_assure, code_assureur)
);

CREATE INDEX idx_code_assure ON assure(code_assure);
CREATE INDEX idx_code_assureur ON assure(code_assureur);


CREATE TABLE IF NOT EXISTS vehicule (
	vid 							int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 					varchar(128) NOT NULL,
	code_assureur 					varchar(128) NOT NULL,
	marque 							varchar(128) NULL,
	modele 							varchar(128) NULL,
	date_premiere_mise_circulation 	date NULL,
	immatriculation 				varchar(128) NOT NULL,
	chassis 						varchar(128) NULL,
	"usage" 						varchar(128) NOT NULL,
	charge_utile 					varchar(128) NULL,
	puissance_fiscale 				numeric NOT NULL,
	remorque 						varchar(128) NOT NULL,
	nombre_portes 					numeric NULL,
	immatriculation_remorque 		varchar(128) NULL,
	source_energie 					varchar(128) NULL,
	nombre_de_places 				numeric NULL,
	cylindree 						numeric NULL,
	double_commande 				numeric NULL,
	responsabilite_civile 			numeric NULL,
	utilitaire 						numeric NULL,
	type_engin 						numeric NULL,
	poids_total_autorise_en_charge 	numeric NULL,
	c_status						numeric NOT NULL DEFAULT 0,
	c_date_creation					timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour				timestamp NULL,
	c_date_transfer					timestamp NULL,
	commentaires 					varchar(255) NULL,

	CONSTRAINT pk_vehicule PRIMARY KEY (immatriculation)
);
CREATE INDEX idx_immatriculation ON vehicule(immatriculation);


CREATE TABLE IF NOT EXISTS remorque (
	rid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 				varchar(128) NOT NULL,
	code_assureur 				varchar(128) NOT NULL,
	immatriculation_remorque 	varchar(128) NOT NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(255) NULL,
	CONSTRAINT pk_remorque PRIMARY KEY (immatriculation_remorque)
);
CREATE INDEX idx_immatriculation_remorque ON vehicule(immatriculation_remorque);


CREATE TABLE IF NOT EXISTS attestation (
	aid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	numero_attestation 			varchar(128) NOT NULL,
	numero_police 				varchar(128) NULL,
	date_emission 				date NULL,
	date_effet 					date NULL,
	date_echeance 				date NULL,
	couleur 					varchar(128) NOT NULL,
	statut 						varchar(128) NOT NULL,
	zone_circulation 			varchar(128) NOT NULL,
	immatriculation 			varchar(128) NOT NULL,
	remorque					varchar(128) NOT NULL,
	code_assure 				varchar(128) NOT NULL,
	code_assureur 				varchar(128) NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(255) NULL,
	CONSTRAINT pk_attestation PRIMARY KEY (numero_attestation)
);
CREATE INDEX idx_attestation_code_assure ON attestation(code_assure);
CREATE INDEX idx_attestation_code_assureur ON attestation(code_assureur);
CREATE INDEX idx_numero_attestation ON attestation(numero_attestation);

CREATE TABLE IF NOT EXISTS vente (
	vid 					int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	numero_attestation 		varchar(128) NOT NULL,
	immatriculation 		varchar(128) NOT NULL,
	code_assure 			varchar(128) NOT NULL,
	code_assureur 			varchar(128) NOT NULL,
	code_intermediaire_dna 	varchar(128) NULL,
	prime_nette_rc 			numeric NOT NULL,
	dta 					numeric NULL,
	c_status				numeric NOT NULL DEFAULT 0,
	c_date_creation			timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour		timestamp NULL,
	c_date_transfer			timestamp NULL,
	commentaires 			varchar(255) NULL,
	CONSTRAINT pk_attestation_vente PRIMARY KEY (numero_attestation, immatriculation)
);
CREATE INDEX idx_vente_code_assure ON vente(code_assure);
CREATE INDEX idx_vente_code_assureur ON vente(code_assureur);
CREATE INDEX idx_vente_numero_attestation ON vente(numero_attestation);
CREATE INDEX idx_vente_immatriculation ON vente(immatriculation);


CREATE TABLE IF NOT EXISTS intermediaire (
	iid 					int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_intermediaire_dna 	varchar(128) NOT NULL,
	num_contribuable 		varchar(128) NULL,
	type_intermediaire 		varchar(128) NOT NULL,
	nom_intermediaire 		varchar(128) NOT NULL,
	telephone 				varchar(128) NOT NULL,
	ville 					varchar(128) NOT NULL,
	boite_postale 			varchar(128) NULL,
	statut_intermediaire 	varchar(128) NOT NULL,
	date_debut_suspension	date,
	date_fin_suspension		date,
	c_status				NUMERIC NOT NULL DEFAULT 0,
	c_date_creation			timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour		timestamp NULL,
	c_date_transfer			timestamp NULL,
	commentaires 			varchar(255) NULL,

	CONSTRAINT pk_intermediaire_iid PRIMARY KEY (iid)
);


CREATE TABLE IF NOT EXISTS ref_sinistre_type_domage (
	taid 	int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	nom 	varchar(128),
	code 	NUMERIC NOT NULL
);

CREATE TABLE IF NOT EXISTS sinistre (
	sid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	reference 					varchar(128) NOT NULL,
	code_assureur 				varchar(128) NOT NULL,
	type_dommage 				varchar(128) NOT NULL,
	cause_sinistre 				varchar(1024) NOT NULL,
	numero_attestation 			varchar(128) NOT NULL,
	date_survenance 			timestamp NOT NULL,
	date_declaration 			timestamp NOT NULL,
	c_status					numeric NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(254) NULL,
	CONSTRAINT pk_num PRIMARY KEY (numero_attestation, reference)
);
CREATE INDEX idx_sinistre_code_assureur ON sinistre(code_assureur);
CREATE INDEX idx_sinistre_numero_attestation ON sinistre(numero_attestation);
CREATE INDEX idx_sinistre_reference ON sinistre(reference);


-----------------JOURNAL TABLES------------------------------------------------

CREATE TABLE IF NOT EXISTS journal_adresse (
	jaid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	boite_postal 				varchar(128) NULL,
	rue 						varchar(128) NULL,
	ville 						varchar(128) NULL,
	pays 						varchar(128) NULL,
	telephone 					varchar(128) NULL,
	email 						varchar(128) NULL,
	web 						varchar(128) NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(125) NULL,
	
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_adresse PRIMARY KEY (j_logdate, jaid)
);
CREATE INDEX idx_journal_adresse ON journal_adresse(j_logdate);


CREATE TABLE IF NOT EXISTS journal_assure (
	jaid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 				varchar(128) NULL,
	code_assureur 				varchar(128) NULL,
	qualite 					varchar(128) NULL,
	nom 						varchar(128) NULL,
	prenom 						varchar(128) NULL,
	profession 					varchar(128) NULL,
	date_naissance 				date NULL,
	num_contribuable 			varchar(128) NULL,
	ville 						varchar(128) NULL,
	rue 						varchar(128) NULL,
	boite_postale 				varchar(128) NULL,
	telephone 					varchar(128) NULL,
	email 						varchar(128) NULL,
	numero_permis 				varchar(128) NULL,
	categorie_permis 			varchar(128) NULL,
	date_delivrance 			date NULL,
	permis_delivre_par 			varchar(128) NULL,
	nom_prenom_conducteur 		varchar(128) NULL,
	date_naissance_conducteur 	date NULL,
	c_status					numeric NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(254) NULL,
	
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_assure PRIMARY KEY (j_logdate, jaid)
);
CREATE INDEX idx_journal_assure ON journal_assure(j_logdate);


CREATE TABLE IF NOT EXISTS journal_vehicule (
	jvid 							int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 					varchar(128) NULL,
	code_assureur 					varchar(128) NULL,
	marque 							varchar(128) NULL,
	modele 							varchar(128) NULL,
	date_premiere_mise_circulation 	date NULL,
	immatriculation 				varchar(128) NULL,
	chassis 						varchar(128) NULL,
	"usage" 						varchar(128) NULL,
	charge_utile 					varchar(128) NULL,
	puissance_fiscale 				numeric NULL,
	remorque 						varchar(128) NULL,
	nombre_portes 					numeric NULL,
	immatriculation_remorque 		varchar(128) NULL,
	source_energie 					varchar(128) NULL,
	nombre_de_places 				numeric NULL,
	cylindree 						numeric NULL,
	double_commande 				numeric NULL,
	responsabilite_civile 			numeric NULL,
	utilitaire 						numeric NULL,
	type_engin 						numeric NULL,
	poids_total_autorise_en_charge 	numeric NULL,
	c_status						numeric NULL DEFAULT 0,
	c_date_creation					timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour				timestamp NULL,
	c_date_transfer					timestamp NULL,
	commentaires 					varchar(255) NULL,

	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_vehicule PRIMARY KEY (j_logdate, jvid)
);
CREATE INDEX idx_journal_vehicule ON journal_vehicule(j_logdate);


CREATE TABLE IF NOT EXISTS journal_remorque (
	jrid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_assure 				varchar(128) NULL,
	code_assureur 				varchar(128) NULL,
	immatriculation_remorque 	varchar(128) NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(255) NULL,
	
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_remorque PRIMARY KEY (j_logdate, jrid)
);
CREATE INDEX idx_journal_remorque ON journal_remorque(j_logdate);


CREATE TABLE IF NOT EXISTS journal_attestation (
	jaid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	numero_attestation 			varchar(128) NULL,
	numero_police 				varchar(128) NULL,
	date_emission 				date NULL,
	date_effet 					date NULL,
	date_echeance 				date NULL,
	couleur 					varchar(128) NULL,
	statut 						varchar(128) NULL,
	zone_circulation 			varchar(128) NULL,
	immatriculation 			varchar(128) NULL,
	remorque					varchar(128) NULL,
	code_assure 				varchar(128) NULL,
	code_assureur 				varchar(128) NULL,
	c_status					NUMERIC NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(255) NULL,
		
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_attestation PRIMARY KEY (j_logdate, jaid)
);
CREATE INDEX idx_journal_attestation ON journal_attestation(j_logdate);


CREATE TABLE IF NOT EXISTS journal_vente (
	jvid 					int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	numero_attestation 		varchar(128) NULL,
	immatriculation 		varchar(128) NULL,
	code_assure 			varchar(128) NULL,
	code_assureur 			varchar(128) NULL,
	code_intermediaire_dna 	varchar(128) NULL,
	prime_nette_rc 			numeric NULL,
	dta 					numeric NULL,
	c_status				numeric NOT NULL DEFAULT 0,
	c_date_creation			timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour		timestamp NULL,
	c_date_transfer			timestamp NULL,
	commentaires 			varchar(255) NULL,
	
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_vente PRIMARY KEY (j_logdate, jvid)
);
CREATE INDEX idx_journal_vente ON journal_vente(j_logdate);


CREATE TABLE IF NOT EXISTS journal_intermediaire (
	jiid 					int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	code_intermediaire_dna 	varchar(128) NULL,
	num_contribuable 		varchar(128) NULL,
	type_assureur 			varchar(128) NULL,
	nom_intermediaire 		varchar(128) NULL,
	telephone 				varchar(128) NULL,
	ville 					varchar(128) NULL,
	boite_postale 			varchar(128) NULL,
	date_debut_suspension	date,
	date_fin_suspension		date,
	c_status				NUMERIC NOT NULL DEFAULT 0,
	c_date_creation			timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour		timestamp NULL,
	c_date_transfer			timestamp NULL,
	commentaires 			varchar(255) null,

	j_logdate				timestamp NOT null default now(),

	CONSTRAINT pk_journal_intermediaire PRIMARY KEY (j_logdate, jiid)
);
CREATE INDEX idx_journal_intermediaire ON journal_intermediaire(j_logdate);


CREATE TABLE IF NOT EXISTS journal_sinistre (
	jsid 						int4 NOT NULL GENERATED BY DEFAULT AS IDENTITY,
	reference 					varchar(128) NULL,
	code_assureur 				varchar(128) NULL,
	type_dommage 				varchar(128) NULL,
	cause_sinistre 				varchar(1024) NULL,
	numero_attestation 			varchar(128) NULL,
	date_survenance 			timestamp NULL,
	date_declaration 			timestamp NULL,
	c_status					numeric NOT NULL DEFAULT 0,
	c_date_creation				timestamp NOT NULL DEFAULT NOW(),
	c_date_mis_a_jour			timestamp NULL,
	c_date_transfer				timestamp NULL,
	commentaires 				varchar(254) NULL,
	
	j_logdate					timestamp NOT null default now(),

	CONSTRAINT pk_journal_sinistre PRIMARY KEY (j_logdate, jsid)
);
CREATE INDEX idx_journal_sinistre ON journal_sinistre(j_logdate);
